Index: trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/classes.nib	(revision 100)
+++ trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/classes.nib	(revision 102)
@@ -20,5 +20,5 @@
             CLASS = PSAlarmsController; 
             LANGUAGE = ObjC; 
-            OUTLETS = {removeButton = NSButton; tableView = NSTableView; }; 
+            OUTLETS = {alarmList = NSTableView; removeButton = NSButton; }; 
             SUPERCLASS = NSWindowController; 
         }
Index: trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/info.nib	(revision 100)
+++ trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/info.nib	(revision 102)
@@ -1,10 +1,10 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
-<plist version="0.9">
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>322 50 356 240 0 0 1280 832 </string>
+	<string>41 63 356 240 0 0 1280 832 </string>
 	<key>IBFramework Version</key>
-	<string>263.2</string>
+	<string>291.0</string>
 	<key>IBOpenObjects</key>
 	<array>
@@ -12,5 +12,5 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>5S66</string>
+	<string>6I32</string>
 </dict>
 </plist>
Index: trunk/Cocoa/Pester/Source/English.lproj/Calendar.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Calendar.nib/classes.nib	(revision 102)
+++ trunk/Cocoa/Pester/Source/English.lproj/Calendar.nib/classes.nib	(revision 102)
@@ -0,0 +1,21 @@
+{
+    IBClasses = (
+        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {CLASS = NJROffCenterPanel; LANGUAGE = ObjC; SUPERCLASS = NSPanel; }, 
+        {CLASS = NSObject; LANGUAGE = ObjC; }, 
+        {
+            ACTIONS = {nextMonth = id; nextYear = id; previousMonth = id; previousYear = id; }; 
+            CLASS = OACalendarView; 
+            LANGUAGE = ObjC; 
+            SUPERCLASS = NSControl; 
+        }, 
+        {
+            ACTIONS = {cancel = id; close = id; today = id; }; 
+            CLASS = PSCalendarController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {calendarView = OACalendarView; delegate = id; okButton = NSButton; }; 
+            SUPERCLASS = NSWindowController; 
+        }
+    ); 
+    IBVersion = 1; 
+}
Index: trunk/Cocoa/Pester/Source/English.lproj/Calendar.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Calendar.nib/info.nib	(revision 102)
+++ trunk/Cocoa/Pester/Source/English.lproj/Calendar.nib/info.nib	(revision 102)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IBDocumentLocation</key>
+	<string>57 27 356 240 0 0 1280 832 </string>
+	<key>IBFramework Version</key>
+	<string>291.0</string>
+	<key>IBOpenObjects</key>
+	<array>
+		<integer>5</integer>
+	</array>
+	<key>IBSystem Version</key>
+	<string>6I32</string>
+</dict>
+</plist>
Index: trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 100)
+++ trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 102)
@@ -48,5 +48,7 @@
                 setAlarm = id; 
                 setSoundRepetitionCount = id; 
+                showCalendar = id; 
                 silence = id; 
+                toggleAlertEditor = id; 
                 update = id; 
             }; 
@@ -72,7 +74,8 @@
                 soundRepetitions = NSTextField; 
                 soundRepetitionsLabel = NSTextField; 
+                timeCalendarButton = NSButton; 
                 timeDate = NSTextField; 
                 timeDateCompletions = NSPopUpButton; 
-                timeInterval = NSTextField; 
+                timeInterval = NJRIntervalField; 
                 timeIntervalRepeats = NSButton; 
                 timeIntervalUnits = NSPopUpButton; 
Index: trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 100)
+++ trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 102)
@@ -9,4 +9,6 @@
 		<key>29</key>
 		<string>130 241 273 44 0 0 1280 832 </string>
+		<key>640</key>
+		<string>63 247 111 180 0 0 1280 832 </string>
 	</dict>
 	<key>IBFramework Version</key>
@@ -15,8 +17,7 @@
 	<array>
 		<integer>29</integer>
-		<integer>21</integer>
 	</array>
 	<key>IBSystem Version</key>
-	<string>6G30</string>
+	<string>6I32</string>
 	<key>IBUserGuides</key>
 	<dict>
@@ -33,4 +34,5 @@
 				<string>Vertical:422.000000</string>
 				<string>Horizontal:151.000000</string>
+				<string>Horizontal:151.000000</string>
 			</array>
 			<key>guidesLocked</key>
Index: trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/classes.nib	(revision 100)
+++ trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/classes.nib	(revision 102)
@@ -10,5 +10,11 @@
         }, 
         {
-            ACTIONS = {close = id; snooze = id; stopRepeating = id; }; 
+            ACTIONS = {
+                close = id; 
+                snooze = id; 
+                snoozeIntervalUnitsChanged = id; 
+                snoozeUntil = id; 
+                stopRepeating = id; 
+            }; 
             CLASS = PSAlarmNotifierController; 
             LANGUAGE = ObjC; 
Index: trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib	(revision 100)
+++ trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib	(revision 102)
@@ -4,7 +4,23 @@
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>122 13 356 240 0 0 1280 832 </string>
+	<string>5 6 356 240 0 0 1280 832 </string>
 	<key>IBFramework Version</key>
 	<string>291.0</string>
+	<key>IBGroupedObjects</key>
+	<dict>
+		<key>1</key>
+		<array>
+			<string>64</string>
+			<string>80</string>
+		</array>
+		<key>2</key>
+		<array>
+			<string>66</string>
+			<string>79</string>
+			<string>82</string>
+		</array>
+	</dict>
+	<key>IBLastGroupID</key>
+	<string>3</string>
 	<key>IBOpenObjects</key>
 	<array>
@@ -12,7 +28,16 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>6G30</string>
+	<string>6I32</string>
 	<key>IBUserGuides</key>
 	<dict>
+		<key>0</key>
+		<dict>
+			<key>guideLocations</key>
+			<array>
+				<string>Horizontal:64.000000</string>
+			</array>
+			<key>guidesLocked</key>
+			<false/>
+		</dict>
 		<key>5</key>
 		<dict>
Index: trunk/Cocoa/Pester/Source/English.lproj/Read Me.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Read Me.nib/classes.nib	(revision 102)
+++ trunk/Cocoa/Pester/Source/English.lproj/Read Me.nib/classes.nib	(revision 102)
@@ -0,0 +1,22 @@
+{
+    IBClasses = (
+        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {
+            ACTIONS = {contentsClicked = id; }; 
+            CLASS = NJRReadMeController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {
+                body = NSTextView; 
+                bodyBox = NSBox; 
+                contents = NSTableView; 
+                contentsBox = NSBox; 
+                progress = NSProgressIndicator; 
+                progressTabs = NSTabView; 
+                splitter = NSSplitView; 
+            }; 
+            SUPERCLASS = NSWindowController; 
+        }, 
+        {CLASS = NJRSplitView; LANGUAGE = ObjC; SUPERCLASS = NSSplitView; }
+    ); 
+    IBVersion = 1; 
+}
Index: trunk/Cocoa/Pester/Source/English.lproj/Read Me.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Read Me.nib/info.nib	(revision 102)
+++ trunk/Cocoa/Pester/Source/English.lproj/Read Me.nib/info.nib	(revision 102)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IBDocumentLocation</key>
+	<string>68 14 356 240 0 0 1280 832 </string>
+	<key>IBFramework Version</key>
+	<string>291.0</string>
+	<key>IBOpenObjects</key>
+	<array>
+		<integer>5</integer>
+	</array>
+	<key>IBSystem Version</key>
+	<string>6I32</string>
+</dict>
+</plist>
Index: trunk/Cocoa/Pester/Source/English.lproj/Snooze until.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Snooze until.nib/classes.nib	(revision 102)
+++ trunk/Cocoa/Pester/Source/English.lproj/Snooze until.nib/classes.nib	(revision 102)
@@ -0,0 +1,20 @@
+{
+    IBClasses = (
+        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {
+            ACTIONS = {close = id; dateCompleted = id; showCalendar = id; snooze = id; update = id; }; 
+            CLASS = PSSnoozeUntilController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {
+                messageField = NSTextField; 
+                snoozeButton = NSButton; 
+                timeCalendarButton = NSButton; 
+                timeDate = NSTextField; 
+                timeDateCompletions = NSPopUpButton; 
+                timeOfDay = NSTextField; 
+            }; 
+            SUPERCLASS = NSWindowController; 
+        }
+    ); 
+    IBVersion = 1; 
+}
Index: trunk/Cocoa/Pester/Source/English.lproj/Snooze until.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Snooze until.nib/info.nib	(revision 102)
+++ trunk/Cocoa/Pester/Source/English.lproj/Snooze until.nib/info.nib	(revision 102)
@@ -0,0 +1,21 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IBDocumentLocation</key>
+	<string>24 13 356 240 0 0 1280 832 </string>
+	<key>IBEditorPositions</key>
+	<dict>
+		<key>70</key>
+		<string>24 258 111 180 0 0 1280 832 </string>
+	</dict>
+	<key>IBFramework Version</key>
+	<string>291.0</string>
+	<key>IBOpenObjects</key>
+	<array>
+		<integer>8</integer>
+	</array>
+	<key>IBSystem Version</key>
+	<string>6I32</string>
+</dict>
+</plist>
Index: trunk/Cocoa/Pester/Source/NJRIntervalField.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRIntervalField.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/NJRIntervalField.m	(revision 102)
@@ -38,4 +38,5 @@
     while ( (i = [e nextObject]) != nil) {
         multiplierTag = [i tag];
+        if (multiplierTag <= 0) continue;
         if (((int)interval % multiplierTag) == 0) {
             NSFormatter *formatter = [self formatter];
@@ -64,7 +65,15 @@
             case 'm': case 'M': tag = 60; break;
             case 'h': case 'H': tag = 60 * 60; break;
+            case 'u': case 'U': tag = -2; break;
             default: break;
         }
-        if (tag != -1) [intervalUnits selectItemAtIndex: [intervalUnits indexOfItemWithTag: tag]];
+        if (tag != -1) {
+            int itemIndex = [intervalUnits indexOfItemWithTag: tag];
+            if (itemIndex != -1) {
+                [intervalUnits selectItemAtIndex: itemIndex];
+                [[intervalUnits menu] performActionForItemAtIndex: itemIndex];
+            }
+            if (tag < 0) return NO; // don't send update
+        }
     }
     return [super textView: textView shouldChangeTextInRange: range replacementString: string];
@@ -73,7 +82,7 @@
 - (void)handleDidFailToFormatString:(NSString *)string errorDescription:(NSString *)error label:(NSString *)label;
 {
-    NSString *alertMessage;
-    NSString *alternateButtonString;
-    NSDecimalNumber *proposedValue;
+    NSString *alertMessage = nil;
+    NSString *alternateButtonString = nil;
+    NSDecimalNumber *proposedValue = nil;
     NSDictionary *contextInfo;
 
Index: trunk/Cocoa/Pester/Source/NJROffCenterPanel.h
===================================================================
--- trunk/Cocoa/Pester/Source/NJROffCenterPanel.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/NJROffCenterPanel.h	(revision 102)
@@ -0,0 +1,16 @@
+//
+//  NJROffCenterPanel.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sat Feb 15 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NJROffCenterPanel : NSPanel {
+
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/NJROffCenterPanel.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJROffCenterPanel.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/NJROffCenterPanel.m	(revision 102)
@@ -0,0 +1,19 @@
+//
+//  NJROffCenterPanel.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sat Feb 15 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "NJROffCenterPanel.h"
+
+
+@implementation NJROffCenterPanel
+
+- (void)center;
+{
+
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/NJRReadMeController.h
===================================================================
--- trunk/Cocoa/Pester/Source/NJRReadMeController.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/NJRReadMeController.h	(revision 102)
@@ -0,0 +1,29 @@
+//
+//  NJRReadMeController.h
+//  Pester
+//
+//  Created by Nicholas Riley on Tue Feb 18 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NJRReadMeController : NSWindowController {
+    IBOutlet NSSplitView *splitter;
+    IBOutlet NSTableView *contents;
+    IBOutlet NSTextView *body;
+    IBOutlet NSBox *bodyBox;
+    IBOutlet NSTabView *progressTabs;
+    IBOutlet NSProgressIndicator *progress;
+    NSMutableArray *headings;
+    float maxHeadingWidth;
+    NSDictionary *headingAttributes;
+}
+
++ (NJRReadMeController *)readMeControllerWithRTFDocument:(NSString *)aPath;
+- (id)initWithRTFDocument:(NSString *)aPath;
+
+- (IBAction)contentsClicked:(NSTableView *)sender;
+
+@end
Index: trunk/Cocoa/Pester/Source/NJRReadMeController.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRReadMeController.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/NJRReadMeController.m	(revision 102)
@@ -0,0 +1,319 @@
+//
+//  NJRReadMeController.m
+//  Pester
+//
+//  Created by Nicholas Riley on Tue Feb 18 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "NJRReadMeController.h"
+#import "NSString-NJRExtensions.h"
+
+@interface NJRHelpContentsEntry : NSObject {
+    unsigned level;
+    NSString *description;
+    NSRange range;
+}
+
++ (NJRHelpContentsEntry *)headingLevel:(int)aLevel description:(NSString *)aDescription range:(NSRange)aRange;
+- (id)initWithLevel:(int)aLevel description:(NSString *)aDescription range:(NSRange)aRange;
+
+- (NSString *)description;
+- (NSRange)range;
+- (NSMutableString *)displayString;
+
+@end
+
+@implementation NJRHelpContentsEntry
+
++ (NJRHelpContentsEntry *)headingLevel:(int)aLevel description:(NSString *)aDescription range:(NSRange)aRange;
+{
+    return [[[self alloc] initWithLevel: aLevel description: aDescription range: aRange] autorelease];
+}
+
+- (id)initWithLevel:(int)aLevel description:(NSString *)aDescription range:(NSRange)aRange;
+{
+    if ( (self = [super init]) != nil) {
+        level = aLevel;
+        description = [[aDescription stringByTrimmingCharactersInSet: [NSCharacterSet whitespaceAndNewlineCharacterSet]] retain];
+        range = aRange;
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [description release];
+    [super dealloc];
+}
+
+- (NSString *)description;
+{
+    return [NSString stringWithFormat: @"%u > %@ %@", level, description, NSStringFromRange(range)];
+}
+
+- (NSRange)range;
+{
+    return range;
+}
+
+- (NSMutableString *)displayString;
+{
+    NSMutableString *s = [[NSMutableString alloc] init];
+
+    unsigned i;
+    for (i = 0 ; i < level ; i++) {
+        [s appendString: @"ÊÊ"];
+    }
+    [s appendString: description];
+    return [s autorelease];
+}
+
+@end
+
+@interface NJRReadMeController (Private)
+- (void)_saveSplit;
+- (void)_restoreSplit;
+@end
+
+@implementation NJRReadMeController
+
+static NJRReadMeController *sharedController = nil;
+
++ (NJRReadMeController *)readMeControllerWithRTFDocument:(NSString *)aPath;
+{
+    return [[self alloc] initWithRTFDocument: aPath];
+}
+
+- (id)initWithRTFDocument:(NSString *)aPath;
+{
+    if (sharedController != nil) {
+        [self release];
+        [[sharedController window] makeKeyAndOrderFront: sharedController];
+        return sharedController;
+    }
+    if ( (self = [super initWithWindowNibName: @"Read Me"]) != nil) {
+        NSWindow *window = [self window];
+        [progress setIndeterminate: YES];
+        [progressTabs selectTabViewItemWithIdentifier: @"progress"];
+
+        [NSThread detachNewThreadSelector: @selector(readRTF:) toTarget: self withObject: aPath];
+        NSString *frameAutosaveName;
+        if ( (frameAutosaveName = [window frameAutosaveName]) == nil) {
+            // XXX workaround for bug in 10.1.5Ð10.2.4 (at least): autosave name set in IB doesn't show up
+            [self setWindowFrameAutosaveName: @"Read Me"];
+            frameAutosaveName = [window frameAutosaveName];
+        }
+        if (frameAutosaveName == nil || ![window setFrameUsingName: frameAutosaveName])
+            [window center];
+        [self _restoreSplit];
+
+        [window makeKeyAndOrderFront: self];
+        sharedController = self;
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [headings release];
+    [headingAttributes release];
+    if (sharedController == self) sharedController = nil;
+    [super dealloc];
+}
+
+- (void)readRTF:(NSString *)aPath;
+{
+    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSAttributedString *readMe = [[NSAttributedString alloc] initWithPath: aPath documentAttributes: nil];
+    if (readMe == nil) {
+        [body insertText: [NSString stringWithFormat: @"CanÕt read document Ò%@Ó", [aPath lastPathComponent]]];
+    } else {
+        NSTextStorage *storage = [body textStorage];
+        [storage setAttributedString: readMe];
+        [readMe release]; readMe = nil;
+
+        unsigned int length = [storage length];
+        [progress setIndeterminate: NO];
+        [progress setMaxValue: length];
+        NSRange effectiveRange = NSMakeRange(0, 0);
+        unsigned int chunkLength = 0;
+        NSFont *fontAttr = nil;
+        NSString *fontName = nil; float fontSize = 0;
+        NSString *heading = nil;
+
+        headings = [[NSMutableArray alloc] init];
+        
+        // XXX need this instead? (id)attribute:(NSString *)attrName atIndex:(unsigned int)location longestEffectiveRange:(NSRangePointer)range inRange:(NSRange)rangeLimit;
+        while (NSMaxRange(effectiveRange) < length) {
+            fontAttr = (NSFont *)[storage attribute: NSFontAttributeName
+                                            atIndex: NSMaxRange(effectiveRange) effectiveRange: &effectiveRange];
+            if (effectiveRange.length < 3) continue;
+            fontName = [fontAttr fontName]; fontSize = [fontAttr pointSize];
+            chunkLength = effectiveRange.length;
+            if ([fontName isEqualToString: @"GillSans-Bold"]) {
+                heading = [[storage attributedSubstringFromRange: effectiveRange] string];
+                if (fontSize == 24)
+                    [headings addObject: [NJRHelpContentsEntry headingLevel: 0 description: [[storage attributedSubstringFromRange: effectiveRange] string] range: effectiveRange]];
+                else
+                    [headings addObject:
+                        [NJRHelpContentsEntry headingLevel: (fontSize == 14) ? 1: 2 description: heading range: effectiveRange]];
+            }
+            if (fontSize != 14) continue;
+            if ([fontName isEqualToString: @"HoeflerText-Black"]) {
+                heading = [[storage attributedSubstringFromRange: NSMakeRange(effectiveRange.location, chunkLength + 1)] string];
+                switch ([heading characterAtIndex: chunkLength]) {
+                    case ':':
+                    case ',':
+                        break;
+                    case ' ':
+                        switch ([heading characterAtIndex: chunkLength - 1]) {
+                            case ':':
+                            case ',':
+                                chunkLength--;
+                                break;
+                            default:
+                                continue;
+                        }
+                        break;
+                    default:
+                        continue;
+                }
+                [headings addObject: [NJRHelpContentsEntry headingLevel: 2 description: [heading substringToIndex: chunkLength] range: NSMakeRange(effectiveRange.location, chunkLength)]];
+            }
+            [progress setDoubleValue: NSMaxRange(effectiveRange)];
+        }
+    }
+    headingAttributes = [[NSDictionary alloc] initWithObjectsAndKeys: [[[contents tableColumnWithIdentifier: @"heading"] dataCell] font], NSFontAttributeName, nil];
+    NSEnumerator *e = [headings objectEnumerator];
+    NSString *s;
+    float width;
+    maxHeadingWidth = 0;
+    while ( (s = [(NJRHelpContentsEntry *)[e nextObject] displayString]) != nil) {
+        width = [s sizeWithAttributes: headingAttributes].width;
+        if (width > maxHeadingWidth) maxHeadingWidth = width;
+    }
+    maxHeadingWidth += 25; // account for scroll bar and frame
+    [self _saveSplit];
+    [self _restoreSplit];
+    
+    [contents reloadData];
+    [progressTabs selectTabViewItemWithIdentifier: @"completed"];
+    [pool release];
+}
+
+- (void)_saveSplit;
+{
+    NSString *frameAutosaveName;
+    if ( (frameAutosaveName = [[self window] frameAutosaveName]) != nil) {
+        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+        [defaults setFloat: maxHeadingWidth forKey:
+            [frameAutosaveName stringByAppendingString: @" maximum contents heading width"]];
+        NSBox *contentsBox = [[splitter subviews] objectAtIndex: 0];
+        [defaults setBool: [splitter isSubviewCollapsed: contentsBox] forKey:
+                [frameAutosaveName stringByAppendingString: @" contents are collapsed"]];
+        [defaults synchronize];
+    }
+}
+
+- (void)_restoreSplit;
+{
+    NSString *frameAutosaveName;
+    BOOL contentsCollapsed = NO;
+    if ( (frameAutosaveName = [[self window] frameAutosaveName]) != nil) {
+        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+        contentsCollapsed = [defaults boolForKey:
+            [frameAutosaveName stringByAppendingString: @" contents are collapsed"]];
+        if (maxHeadingWidth == 0) { // don't want to restore 0 if we can't write to defaults
+            maxHeadingWidth = [defaults floatForKey:
+                [frameAutosaveName stringByAppendingString: @" maximum contents heading width"]];
+        }
+    }
+    NSBox *contentsBox = [[splitter subviews] objectAtIndex: 0];
+    if ([splitter isSubviewCollapsed: contentsBox] ||
+        (maxHeadingWidth == 0 && !contentsCollapsed)) return;
+    if (contentsCollapsed) {
+        [splitter performSelectorOnMainThread: @selector(collapseSubview:) withObject: contentsBox waitUntilDone: YES];
+        return;
+    }
+    NSSize contentsSize = [contentsBox frame].size;
+    float widthDiff = contentsSize.width - maxHeadingWidth;
+    if (widthDiff < 1) return;
+    NSSize bodySize = [bodyBox frame].size;
+    bodySize.width += widthDiff;
+    contentsSize.width -= widthDiff;
+    [contentsBox setFrameSize: contentsSize];
+    [bodyBox setFrameSize: bodySize];
+    [splitter performSelectorOnMainThread: @selector(adjustSubviews) withObject: nil waitUntilDone: NO];
+}
+
+- (IBAction)contentsClicked:(NSTableView *)sender;
+{
+    int row = [sender clickedRow];
+    if (row == -1) return;
+    NSRange range = [[headings objectAtIndex: row] range];
+    [body setSelectedRange: range];
+    [body scrollRangeToVisible: range];
+}
+
+@end
+
+@implementation NJRReadMeController (NSTableDataSource)
+
+- (int)numberOfRowsInTableView:(NSTableView *)tableView;
+{
+    return [headings count];
+}
+
+// need to enable column resizing for this to work, otherwise we never get called again
+- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row;
+{
+    NSMutableString *s = [[headings objectAtIndex: row] displayString];
+    [s truncateToWidth: [tableView frameOfCellAtColumn: 0 row: row].size.width by: NSLineBreakByTruncatingTail withAttributes: headingAttributes];
+    return s;
+}
+
+@end
+
+@implementation NJRReadMeController (NSSplitViewDelegate)
+
+- (float)splitView:(NSSplitView *)sender constrainMinCoordinate:(float)proposedCoord ofSubviewAt:(int)offset;
+{
+    return MAX(proposedCoord, 80);
+}
+
+- (float)splitView:(NSSplitView *)sender constrainMaxCoordinate:(float)proposedCoord ofSubviewAt:(int)offset;
+{
+    return MIN(proposedCoord, maxHeadingWidth);
+}
+
+- (void)splitView:(NSSplitView *)sender resizeSubviewsWithOldSize:(NSSize)oldSize;
+{
+    NSSize newSize = [sender frame].size;
+    NSBox *contentsBox = [[splitter subviews] objectAtIndex: 0];
+    NSSize contentsSize = [contentsBox frame].size;
+    NSSize bodySize = [bodyBox frame].size;
+    contentsSize.height += newSize.height - oldSize.height;
+    [contentsBox setFrameSize: contentsSize];
+    bodySize.width += newSize.width - oldSize.width;
+    bodySize.height += newSize.height - oldSize.height;
+    [bodyBox setFrameSize: bodySize];
+    [sender adjustSubviews];
+}
+
+- (BOOL)splitView:(NSSplitView *)sender canCollapseSubview:(NSView *)subview;
+{
+    return [contents isDescendantOf: subview];
+}
+
+@end
+
+@implementation NJRReadMeController (NSWindowNotifications)
+
+- (void)windowWillClose:(NSNotification *)notification;
+{
+    [self _saveSplit];
+    [self autorelease];
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/NJRSplitView.h
===================================================================
--- trunk/Cocoa/Pester/Source/NJRSplitView.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/NJRSplitView.h	(revision 102)
@@ -0,0 +1,19 @@
+//
+//  NJRSplitView.h
+//  Pester
+//
+//  Created by Nicholas Riley on Thu Feb 20 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NJRSplitView : NSSplitView {
+    float expandedWidth;
+}
+
+- (void)collapseSubview:(NSView *)subview;
+- (void)expandSubview:(NSView *)subview;
+
+@end
Index: trunk/Cocoa/Pester/Source/NJRSplitView.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRSplitView.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/NJRSplitView.m	(revision 102)
@@ -0,0 +1,97 @@
+//
+//  NJRSplitView.m
+//  Pester
+//
+//  Created by Nicholas Riley on Thu Feb 20 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "NJRSplitView.h"
+
+
+@implementation NJRSplitView
+
+// inspiration (but very little code remaining) from <http://cocoa.mamasam.com/COCOADEV/2003/02/1/55911.php>
+// XXX need to generalize: assumes the split is vertical, and you want to collapse a previous view
+// XXX shouldn't set width to 0 as it can destroy layouts, but we have no other choice
+
+- (void)collapseSubview:(NSView *)subview;
+{
+    NSSize size = [subview frame].size;
+    NSAssert([self isVertical] && size.width > 1, @"unsupported configuration");
+    expandedWidth = size.width;
+    size.width = 0;
+    [subview setFrameSize: size];
+    [self setNeedsDisplay: YES];
+}
+
+// XXX this is a horrendous hack to work around NSSplitView bugs, and leaks memory
+- (void)expandSubview:(NSView *)subview;
+{
+    NSArray *subviews = [self subviews];
+    NSAssert([subviews count] == 2, @"unsupported configuration");
+    NSBox *leftView = [subviews objectAtIndex: 0];
+    NSView *rightView = [subviews objectAtIndex: 1];
+    NSRect leftFrame = [leftView frame], rightFrame = [rightView frame];
+    NSAssert([self isVertical] && subview == leftView, @"unsupported configuration");
+    if (expandedWidth == 0) {
+        expandedWidth = (rightFrame.size.width - [self dividerThickness]) / 2;
+    }
+    if ([[self delegate] respondsToSelector: @selector(splitView:constrainMaxCoordinate:ofSubviewAt:)]) {
+        expandedWidth = [[self delegate] splitView: self constrainMaxCoordinate: expandedWidth ofSubviewAt: 0];
+    }
+    // begin hack
+    NSBox *newLeftView = [[NSBox alloc] initWithFrame: leftFrame];
+    [newLeftView setBorderType: [leftView borderType]];
+    [newLeftView setTitlePosition: [leftView titlePosition]];
+    [newLeftView setBoxType: [leftView boxType]];
+    [newLeftView setAutoresizingMask: [leftView autoresizingMask]];
+    [newLeftView setContentViewMargins: [leftView contentViewMargins]];
+    NSView *leftContentView = [leftView contentView];
+    [leftContentView retain];
+    [leftContentView removeFromSuperviewWithoutNeedingDisplay];
+    [newLeftView setContentView: leftContentView];
+    [leftContentView release];
+    leftFrame.origin = NSZeroPoint;
+    rightFrame.origin.x += expandedWidth;
+    leftFrame.size.width = expandedWidth;
+    rightFrame.size.width -= expandedWidth;
+    [leftView removeFromSuperviewWithoutNeedingDisplay];
+    [rightView retain];
+    [rightView removeFromSuperviewWithoutNeedingDisplay];
+    [newLeftView setFrame: leftFrame];
+    [rightView setFrame: rightFrame];
+    [self addSubview: newLeftView];
+    [self addSubview: rightView];
+    [newLeftView release];
+    [rightView release];
+    // end hack
+    [self setNeedsDisplay: YES];
+}
+
+- (void)mouseDown:(NSEvent *)event;
+{
+    if ([event clickCount] == 2) {
+        NSPoint location = [self convertPoint: [event locationInWindow] fromView: nil];
+        NSArray *subviews = [self subviews];
+        NSView *leftView = [subviews objectAtIndex: 0];
+        if (NSPointInRect(location, [leftView frame]) ||
+            NSPointInRect(location, [[subviews objectAtIndex: 1] frame])) return;
+        if ([self isSubviewCollapsed: leftView]) {
+            [self expandSubview: leftView];
+        } else {
+            [self collapseSubview: leftView];
+        }
+    }
+    [super mouseDown: event];
+}
+
+- (BOOL)isSubviewCollapsed:(NSView *)subview;
+{
+    NSRect frame = [subview frame];
+    if (frame.origin.x == 1e6) return YES;
+    if (frame.size.width <= 1) return YES;
+    return NO;
+}
+
+@end
